// #autoload
// #name = FPSHud
// #version = 1.0
// #date = 04 November, 2003
// #category = ilys' Scripts
// #config = FPSHudOptions

$FPSHud::Update = 500;
$FPSHud::LabelColour = "FFFFFF";
$FPSHud::fontType = "Univers Condensed";
$FPSHud::fontSize = 16;
$FPSHud::Good::Low = 61;
$FPSHud::Good::High = 150;
$FPSHud::Good::TextColour = "00FF00";
$FPSHud::Poor::Low = 31;
$FPSHud::Poor::High = 60;
$FPSHud::Poor::TextColour = "FFFF00";
$FPSHud::Bad::Low = 10;
$FPSHud::Bad::High = 30;
$FPSHud::Bad::TextColour = "FF0000";

if(isFile("prefs/FPSHudPrefs.cs")) exec("prefs/FPSHudPrefs.cs");

package FPSHud
{
function PlayGui::onWake(%this)
{
	parent::onWake(%this);
	if(!isObject(FPSHud))
	{
		new GuiControlProfile("FPSHudTextCtrl")
		{
			fontType = $FPSHud::fontType;
			fontSize = $FPSHud::fontSize;
			fontColor = "255 255 255";
			justify = "left";
		};
		new ShellFieldCtrl(FPSHud)
		{
			profile = "GuiConsoleProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "0 0";
			extent = "50 16";
			minExtent = "8 8";
			visible = "1";
			new GuiMLTextCtrl(FPSHudText)
			{
				profile = "FPSHudTextCtrl";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "50 16";
				visible = "1";
			};
		};
		playGui.add(FPSHud);
		if(isObject(HM) && isObject(HudMover)) hudmover::addhud(FPSHud,"FPSHud");
		FPSHudUpdate();
	}
}

function FPSHudUpdate()
{
	if($FPSHudSchedule != 0) cancel($FPSHudSchedule);
	$fps::real = mFloor($fps::real);
	if($fps::real > $FPSHud::Good::High)
		FPSHudText.setText("<just:left><color:"@$FPSHud::LabelColour@">FPS <just:right><color:FFFFFF>"@$fps::real);
	else if($fps::real >= $FPSHud::Good::Low && $fps::real <= $FPSHud::Good::High)
		FPSHudText.setText("<just:left><color:"@$FPSHud::LabelColour@">FPS <just:right><color:"@$FPSHud::Good::TextColour@">"@$fps::real);
	else if($fps::real >= $FPSHud::Poor::Low && $fps::real <= $FPSHud::Poor::High)
		FPSHudText.setText("<just:left><color:"@$FPSHud::LabelColour@">FPS <just:right><color:"@$FPSHud::Poor::TextColour@">"@$fps::real);
	else if($fps::real >= $FPSHud::Bad::Low && $fps::real < $FPSHud::Bad::High)
		FPSHudText.setText("<just:left><color:"@$FPSHud::LabelColour@">FPS <just:right><color:"@$FPSHud::Bad::TextColour@">"@$fps::real);
	else if($fps::real < $FPSHud::Bad::Low)
		FPSHudText.setText("<just:left><color:"@$FPSHud::LabelColour@">FPS <just:right><color:000000>"@$fps::real);

	$FPSHudSchedule = schedule($FPSHud::Update, 0, FPSHudupdate);
}

function FPSHudSavePrefs()
{
	if($FPSHud::Bad::High <= $FPSHud::Bad::Low)
	{
		$FPSHud::Bad::Hight = $FPSHud::Poor::Low + 1;
		FPSHudBadHigh.setValue($FPSHud::Bad::High);
	}
	if($FPSHud::Poor::Low <= $FPSHud::Bad::High)
	{
		$FPSHud::Poor::Low = $FPSHud::Bad::High + 1;
		FPSHudPoorLow.setValue($FPSHud::Poor::Low);
	}
	if($FPSHud::Poor::High <= $FPSHud::Poor::Low)
	{
		$FPSHud::Poor::High = $FPSHud::Poor::Low + 1;
		FPSHudPoorHigh.setValue($FPSHud::Poor::High);
	}
	if($FPSHud::Good::Low <= $FPSHud::Poor::High)
	{
		$FPSHud::Good::Low = $FPSHud::Poor::High + 1;
		FPSHudGoodLow.setValue($FPSHud::Good::Low);
	}
	if($FPSHud::Good::High <= $FPSHud::Good::Low)
	{
		$FPSHud::Good::High = $FPSHud::Good::Low + 1;
		FPSHudGoodHigh.setValue($FPSHud::Good::High);
	}

	export("$FPSHud::*", "prefs/FPSHudPrefs.cs", false);
}

function FPSHudOptions::OnWake()
{
	// No console spam please
}
};
activatePackage(FPSHud);

new GuiControl(FPSHudOptions)
{
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "210 210";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";
	new ShellFieldCtrl()
	{
		profile = "ShellFieldProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "210 210";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		new GuiTextCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 10";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Refresh(ms)";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTextEditCtrl(FPSHudUpdate)
		{
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "20 20";
			extent = "80 30";
			minExtent = "32 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$FPSHud::Update";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			glowOffset = "9 9";
		};
		new ShellBitmapButton()
		{
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "105 20";
			extent = "80 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "FPSHudSavePrefs();";
			helpTag = "0";
			text = "Save";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new GuiTextCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "60 60";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Low";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new GuiTextCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "140 60";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "High";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new GuiTextCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 90";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Good";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTextEditCtrl(FPSHudGoodLow)
		{
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "50 80";
			extent = "80 30";
			minExtent = "32 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$FPSHud::Good::Low";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			glowOffset = "9 9";
		};
		new ShellTextEditCtrl(FPSHudGoodHigh)
		{
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "130 80";
			extent = "80 30";
			minExtent = "32 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$FPSHud::Good::High";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			glowOffset = "9 9";
		};
		new GuiTextCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 115";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Poor";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTextEditCtrl(FPSHudPoorLow)
		{
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "50 105";
			extent = "80 30";
			minExtent = "32 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$FPSHud::Poor::Low";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			glowOffset = "9 9";
		};
		new ShellTextEditCtrl(FPSHudPoorHigh)
		{
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "130 105";
			extent = "80 30";
			minExtent = "32 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$FPSHud::Poor::High";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			glowOffset = "9 9";
		};
		new GuiTextCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 140";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Bad";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTextEditCtrl(FPSHudBadLow)
		{
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "50 130";
			extent = "80 30";
			minExtent = "32 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$FPSHud::Bad::Low";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			glowOffset = "9 9";
		};
		new ShellTextEditCtrl(FPSHudBadHigh)
		{
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "130 130";
			extent = "80 30";
			minExtent = "32 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$FPSHud::Bad::High";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			glowOffset = "9 9";
		};
	};
};